#ifndef KANGAROO_H
#define KANGAROO_H

#include "common.h"

#include "mycube.h"
#include "kleg.h"
#include "ktail.h"
#include "karm.h"
#include "khead.h"

class Kangaroo
{
public:
	Kangaroo(); // default constructor
	
	void drawIt(); // draws the kangaroo and handles animation
	
	void toggleLeftLeg();
	void toggleRightLeg();
	void toggleHeadSwivel();
	void toggleLeftArm();
	void toggleTailCurl();
	void toggleHop();
	void toggleBackflip();
	
	void toggleTransitionMode();

private:
	void drawTorso();
	
	KLeg left_leg;
	KLeg right_leg;
	KTail tail;
	KArm left_arm;
	KArm right_arm;
	KHead head;
	
	bool animate_smoothly;
	
	void doHop();
	bool hopping; bool flipping;
	bool waitingForCrouch; //assists in hopping
	float elevation;
	float spin;
	float head_tilt;
	int hopcounter;
};

#endif
