#include "common.h"
double myRandom(double start,double end)
{
	return( ( rand() * ( end - start ) / RAND_MAX ) + start );
}

int signOf(double val)
{
	if(val <0)
		return -1;
	else return 1;

}
double absD(double val)
{
	return val * signOf(val);
}
double sqr(double v)
{
	return v *v;
}
void DrawScaledBox(double scaleX,double scaleY,double scaleZ)
//
// Scales the coordinates before drawing a cube and then reverts back.
// Convenient for avoiding diamond looking cubes.
//
{
        glPushMatrix();
        glScalef(scaleX,scaleY,scaleZ);
        glutSolidCube(1);
        glPopMatrix();
}
void DrawAxes(int lineLength)	//debug function that just draws axes in current coord frame
{
	glLineWidth(3);
	glColor3f( 1, 0, 0 );
	glBegin(GL_LINES);
	glVertex3f(0,0,0);
	glVertex3f(1.0 * lineLength,0,0);
	glEnd();
 	glColor3f( 0, 1, 0 );
	glBegin(GL_LINES);
	glVertex3f(0,0,0);
	glVertex3f(0,1.0 * lineLength,0);
	glEnd();
 	glColor3f(0,0,1);
	glBegin(GL_LINES);
	glVertex3f(0,0,0);
	glVertex3f(0,0,1.0 * lineLength);
	glEnd();
}
void DrawArrow(double * arrow,double * startPt,int lineLength,double rColor,double gColor,double bColor)
{
	glLineWidth(3);
	glColor3f( rColor, gColor, bColor );	
	glBegin(GL_LINES);
	double dirX = arrow[0] * lineLength;
	double dirY = arrow[1] * lineLength;
	double dirZ = arrow[2] * lineLength;
	glVertex3dv(startPt);
	glVertex3d(startPt[0] + dirX,startPt[1] + dirY,startPt[2] + dirZ);
	glEnd();
}
void DrawTexturedBox(double scaleX,double scaleY,double scaleZ)
//
// Scales the coordinates before drawing a cube and then reverts back.
// Convenient for avoiding diamond looking cubes.
//
{
        glPushMatrix();
        glScalef(scaleX /2,scaleY/2,scaleZ/2);
        //cube code starts
	glBegin(GL_QUADS);		// Draw The Cube Using quads
	//glColor3f(0.0f,1.0f,0.0f);	// Color Blue
	glTexCoord2d(1,0);	
	glVertex3f( 1.0f, 1.0f,-1.0f);	// Top Right Of The Quad (Top)	
	glTexCoord2d(0,0);	
	glVertex3f(-1.0f, 1.0f,-1.0f);	// Top Left Of The Quad (Top)
	glTexCoord2d(0,1);	
	glVertex3f(-1.0f, 1.0f, 1.0f);	// Bottom Left Of The Quad (Top)
	glTexCoord2d(1,1);	
	glVertex3f( 1.0f, 1.0f, 1.0f);	// Bottom Right Of The Quad (Top)
	
	//glColor3f(1.0f,0.5f,0.0f);	// Color Orange
	glTexCoord2d(1,1);	
	glVertex3f( 1.0f,-1.0f, 1.0f);	// Top Right Of The Quad (Bottom)
	glTexCoord2d(0,1);	
	glVertex3f(-1.0f,-1.0f, 1.0f);	// Top Left Of The Quad (Bottom)
	glTexCoord2d(0,0);	
	glVertex3f(-1.0f,-1.0f,-1.0f);	// Bottom Left Of The Quad (Bottom)
	glTexCoord2d(1,0);	
	glVertex3f( 1.0f,-1.0f,-1.0f);	// Bottom Right Of The Quad (Bottom)
	
	//glColor3f(1.0f,0.0f,0.0f);	// Color Red	
	glTexCoord2d(1,1);	
	glVertex3f( 1.0f, 1.0f, 1.0f);	// Top Right Of The Quad (Front)
	glTexCoord2d(0,1);	
	glVertex3f(-1.0f, 1.0f, 1.0f);	// Top Left Of The Quad (Front)
	glTexCoord2d(0,0);	
	glVertex3f(-1.0f,-1.0f, 1.0f);	// Bottom Left Of The Quad (Front)
	glTexCoord2d(1,0);	
	glVertex3f( 1.0f,-1.0f, 1.0f);	// Bottom Right Of The Quad (Front)
	
	//glColor3f(1.0f,1.0f,0.0f);	// Color Yellow
	glTexCoord2d(1,0);	
	glVertex3f( 1.0f,-1.0f,-1.0f);	// Top Right Of The Quad (Back)
	glTexCoord2d(0,0);	
	glVertex3f(-1.0f,-1.0f,-1.0f);	// Top Left Of The Quad (Back)
	glTexCoord2d(0,1);	
	glVertex3f(-1.0f, 1.0f,-1.0f);	// Bottom Left Of The Quad (Back)
	glTexCoord2d(1,1);	
	glVertex3f( 1.0f, 1.0f,-1.0f);	// Bottom Right Of The Quad (Back)
	//glColor3f(0.0f,0.0f,1.0f);	// Color Blue
	glTexCoord2d(1,1);	
	glVertex3f(-1.0f, 1.0f, 1.0f);	// Top Right Of The Quad (Left)
	glTexCoord2d(1,0);	
	glVertex3f(-1.0f, 1.0f,-1.0f);	// Top Left Of The Quad (Left)
	glTexCoord2d(0,0);	
	glVertex3f(-1.0f,-1.0f,-1.0f);	// Bottom Left Of The Quad (Left)
	glTexCoord2d(0,1);	
	glVertex3f(-1.0f,-1.0f, 1.0f);	// Bottom Right Of The Quad (Left)
	//glColor3f(1.0f,0.0f,1.0f);	// Color Violet
	glTexCoord2d(1,0);	
	glVertex3f( 1.0f, 1.0f,-1.0f);	// Top Right Of The Quad (Right)
	glTexCoord2d(1,1);	
	glVertex3f( 1.0f, 1.0f, 1.0f);	// Top Left Of The Quad (Right)
	glTexCoord2d(0,1);	
	glVertex3f( 1.0f,-1.0f, 1.0f);	// Bottom Left Of The Quad (Right)
	glTexCoord2d(0,0);	
	glVertex3f( 1.0f,-1.0f,-1.0f);	// Bottom Right Of The Quad (Right)
	glEnd();			// End Drawing The Cube

  //cube code ends
	glPopMatrix();
}


