#ifndef CUSTOMBOX_CPP
#define CUSTOMBOX_CPP

#include "common.h"
#include "face.cpp"
#include "corner.cpp"

class CustomBox
{
	public:
	Corner points[8];
	Face front;
	Face back;
	Face top;
	Face bottom;
	Face left;
	Face right;
	double texCoordsTemplate[4][2];
	CustomBox()
	{
		texCoordsTemplate[0][0] = 0;
		texCoordsTemplate[0][1] = 0;
		
		texCoordsTemplate[1][0] = 1;
		texCoordsTemplate[1][1] = 0;
		
		texCoordsTemplate[2][0] = 1;
		texCoordsTemplate[2][1] = 1;
		
		texCoordsTemplate[3][0] = 0;
		texCoordsTemplate[3][1] = 1;		
	}
	void set(Corner * v1,Corner * v2,Corner * v3,Corner * v4,Corner * v5,Corner * v6,Corner * v7,Corner * v8)
	{
		int i;
		points[0].set(v1);
		points[1].set(v2);
		points[2].set(v3);
		points[3].set(v4);
		points[4].set(v5);
		points[5].set(v6);
		points[6].set(v7);
		points[7].set(v8);
		
		front.addVertex(&points[0]);
		front.addVertex(&points[1]);
		front.addVertex(&points[2]);
		front.addVertex(&points[3]);	
		front.calculateNormal();
		
		back.addVertex(&points[7]);
		back.addVertex(&points[6]);
		back.addVertex(&points[5]);
		back.addVertex(&points[4]);
		front.calculateNormal();
		
		left.addVertex(&points[0]);
		left.addVertex(&points[3]);
		left.addVertex(&points[7]);
		left.addVertex(&points[4]);
		front.calculateNormal();
	
		right.addVertex(&points[1]);
		right.addVertex(&points[5]);
		right.addVertex(&points[6]);
		right.addVertex(&points[2]);
		front.calculateNormal();
	
			
		top.addVertex(&points[3]);
		top.addVertex(&points[2]);
		top.addVertex(&points[6]);
		top.addVertex(&points[7]);
		front.calculateNormal();
			
		bottom.addVertex(&points[0]);
		bottom.addVertex(&points[4]);
		bottom.addVertex(&points[5]);
		bottom.addVertex(&points[1]);
		front.calculateNormal();
		
		for(i=0;i < 4;i++)
		{
			((Corner *)front.getVertex(i))->addFace(&front);
			((Corner *)back.getVertex(i))->addFace(&front);
			((Corner *)left.getVertex(i))->addFace(&front);
			((Corner *)right.getVertex(i))->addFace(&front);
			((Corner *)top.getVertex(i))->addFace(&front);
			((Corner *)bottom.getVertex(i))->addFace(&front);		
		}
		for(i=0;i < 8;i++)
		{
			points[i].calculateNormal();		
		}

	}	
	~CustomBox()
	{
	
	}
	void draw()	
	{
		int i;	
		Corner * p;
		glBegin(GL_POLYGON);
		for(i =0;i < 4;i++)
		{		
			p = (Corner *)front.getVertex(i);
			glNormal3dv(p->getNormal()->getCoords());
			glTexCoord2d(texCoordsTemplate[i][0],texCoordsTemplate[i][1]);
			glVertex3dv(p->getCoords());	
		}
		glEnd();
		glBegin(GL_POLYGON);
		for(i =0;i < 4;i++)
		{
			p = (Corner *)back.getVertex(i);
			glNormal3dv(p->getNormal()->getCoords());
			glTexCoord2d(texCoordsTemplate[i][0],texCoordsTemplate[i][1]);
			glVertex3dv(p->getCoords());	
		}
		
		glEnd();
		glBegin(GL_POLYGON);
		for(i =0;i < 4;i++)
		{
			p = (Corner *)left.getVertex(i);
			glNormal3dv(p->getNormal()->getCoords());
			glTexCoord2d(texCoordsTemplate[i][0],texCoordsTemplate[i][1]);
			glVertex3dv(p->getCoords());	
		}
		glEnd();
		glBegin(GL_POLYGON);
		for(i =0;i < 4;i++)
		{
			p = (Corner *)right.getVertex(i);
			glNormal3dv(p->getNormal()->getCoords());
			glTexCoord2d(texCoordsTemplate[i][0],texCoordsTemplate[i][1]);
			glVertex3dv(p->getCoords());	
		}
		glEnd();
		glBegin(GL_POLYGON);
		for(i =0;i < 4;i++)
		{
			p = (Corner *)top.getVertex(i);
			glNormal3dv(p->getNormal()->getCoords());
			glTexCoord2d(texCoordsTemplate[i][0],texCoordsTemplate[i][1]);
			glVertex3dv(p->getCoords());	
		}
		glEnd();
		glBegin(GL_POLYGON);
		for(i =0;i < 4;i++)
		{
			p = (Corner *)bottom.getVertex(i);
			glNormal3dv(p->getNormal()->getCoords());
			glTexCoord2d(texCoordsTemplate[i][0],texCoordsTemplate[i][1]);
			glVertex3dv(p->getCoords());	
		}
		glEnd();		
	
	}
};
#endif

