#ifndef EXPLOSION
#define EXPLOSION

#include "common.h"
#include "geometry.cpp"
#include "blobtex.h"
#include <cstdio>
#include <cmath>

#define NUMPARTICLES 200
#define NUMBLOBS 400

struct Particle
{
	bool alive;
	float life;
	float fade;
	Color color;
	Vertex position;
	Vertex oldpos;
	Arrow velocity;
	Arrow accel;
};

struct Fuzzy
{
	bool alive;
	float life;
	float fade;
	Vertex pos;
	float rotation;
	Vertex velocity;
	Vertex accel;
};

class Explosion
{
public:
	Explosion( int spread = 360 );
	~Explosion();
	
	void reset(); //reset particles if you want to reuse an instance
	bool draw(); //render particles and update them. returns true if some
	             //particles are still active

private:
	Particle particles[NUMPARTICLES];
	
	int spread;
	
	BlobTexture* texture;
	
	Fuzzy fuzzies[NUMBLOBS];
};

#endif
