#ifndef FIRE
#define FIRE

#include "common.h"
#include "geometry.cpp"
#include "perlin2d.h"
#include "texture.h"
#include "blobtex.h"
#include <cstdlib>

#define NUM_BLOBS 350

struct Blob
{
	float rotation;
	Vertex pos;
	int row; //row and col are indices in the perlin noise array
	int col;
	float speed;
};

class Fire
{
public:
	Fire(bool points = false);
	~Fire();
	void draw();
	void update();
	void reset();

private:
	bool points;
	BlobTexture* texture;
	PerlinNoise2D noise;
	Blob blobs[NUM_BLOBS];
	void newBlob(int i);
	
	
};

#endif
