#ifndef FIREWELL
#define FIREWELL

#include "common.h"
#include "texture.h"

extern TEXTURE wallTex;

class FireWell
{
public:
	GLUquadricObj* quad;
	GLuint dlist;
	
	FireWell() {}
	~FireWell() {}
	void init()
	{
		quad = gluNewQuadric();
		gluQuadricDrawStyle(quad, GLU_FILL);
		gluQuadricNormals(quad, GLU_SMOOTH);
		gluQuadricTexture(quad, GL_TRUE);
		dlist = glGenLists(1);
		
		glNewList(dlist, GL_COMPILE);
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, wallTex.TexID);
			glMatrixMode(GL_TEXTURE);
			glPushMatrix();
			glScalef(3.0, 0.3, 1.0);
			glMatrixMode(GL_MODELVIEW);
			glColor3f(1,1,1);
			gluQuadricOrientation(quad, GLU_OUTSIDE);
			glPushMatrix();
			glRotatef(-90, 1, 0, 0);
				gluCylinder(quad, 2.5, 2.5, 1.0, 20, 20);
				glPushMatrix();
					glTranslatef(0, 0, 1.0);
					gluDisk(quad, 2.0, 2.5, 20, 20);
				glPopMatrix();
				gluQuadricOrientation(quad, GLU_INSIDE);
				gluCylinder(quad, 2.0, 2.0, 1.0, 20, 20);
			glPopMatrix();
			glMatrixMode(GL_TEXTURE);
			glPopMatrix();
			glMatrixMode(GL_MODELVIEW);
		glEndList();
	}
	
	void draw()
	{
		glCallList(dlist);
	}
};

#endif
