#ifndef GEOMETRY_CPP
#define GEOMETRY_CPP
#include "common.h"


#define Arrow Coord3d
#define Vertex Coord3d
#define Color Coord3d

class Coord4f  //represents a vertex and only stores coordinates
{
public:
	float coords[4];

	Coord4f(float v1,float v2,float v3,float v4)
	{
		coords[0] = v1;
		coords[1] = v2;
		coords[2] = v3;
	}
	void set(float  v1,float v2, float v3,float v4)
	{
		coords[0]= v1;
		coords[1]= v2;
		coords[2]= v3;
		coords[3]= v3;
	}
	
	Coord4f(Coord4f * src)
	{
		set(src->coords[0],src->coords[1],src->coords[2],src->coords[3]);
	}
	void set(Coord4f * src)
	{
		set(src->coords[0],src->coords[1],src->coords[2],src->coords[3]);
	}
	
	Coord4f()
	{
		coords[0] = coords[1] = coords[2] = coords[3] = 0;
	}
	~Coord4f()
	{
	}
	float getCoord(int index)
	{
		return coords[index];
	}
	void setCoord(int index,float  val)
	{
		coords[index] = val;
	}
	
	float * getCoords()
	{
		return (float *)coords;
	}
	Coord4f sub(Coord4f * other)
	{
		Coord4f res;
		res.set(coords[0] - other->coords[0], coords[1] - other->coords[1], coords[2] - other->coords[2],coords[3] - 
		other->coords[3]);
		return res;				
	}
};



class Coord3d  //represents a vertex and only stores coordinates
{
public:
	double coords[3];
	Coord3d(double v1,double v2,double v3)
	{
		coords[0] = v1;
		coords[1] = v2;
		coords[2] = v3;
	}
	Coord3d& operator=(const Coord3d& c) { 
		coords[0] = c.coords[0];
		coords[1] = c.coords[1];
		coords[2] = c.coords[2];
		return *this;
	}
	void print()
	{
		printf("\n(%f,%f,%f)",coords[0],coords[1],coords[2]);
	}
	Coord3d(Coord3d * src)
	{
		coords[0] = src->coords[0];
		coords[1] = src->coords[1];
		coords[2] = src->coords[2];
	}

	void set(Coord3d * src)
	{
		coords[0] = src->coords[0];
		coords[1] = src->coords[1];
		coords[2] = src->coords[2];
	}
	
	Coord3d()
	{
		coords[0] = coords[1] = coords[2] = 0;
	}
	~Coord3d()
	{
	}
	double getCoord(int index)
	{
		return coords[index];
	}
	void setCoord(int index,double  val)
	{
		coords[index] = val;
	}
	
	void set(double  v1,double v2, double v3)
	{
		coords[0]= v1;
		coords[1]= v2;
		coords[2]= v3;
	}

	double * getCoords()
	{
		return (double *)coords;
	}
	Coord3d sub(Coord3d * other)
	{
		Coord3d res;
		res.set(coords[0] - other->coords[0], coords[1] - other->coords[1], coords[2] - other->coords[2]);
		return res;				
	}
	Coord3d add(Coord3d * other)
	{
		Coord3d res;
		res.set(coords[0] + other->coords[0], coords[1] + other->coords[1], coords[2] + other->coords[2]);
		return res;				
	}
	Coord3d mul(double value)
	{
		Coord3d res;
		res.set(coords[0] * value, coords[1]* value, coords[2]* value);
		return res;						
	}
	double getLength()
	{
		return sqrt(coords[0] *coords[0] + coords[1] *coords[1] + coords[2]*coords[2]);
	}
	double getX()
	{
		return coords[0];
	}
	double getY()
	{
		return coords[1];
	}
	double getZ()
	{
		return coords[2];
	}
	void setX(double val)
	{
		coords[0] = val;
	}
	void setY(double val)
	{
		coords[1] = val;
	}
	void setZ(double val)
	{
		coords[2] = val;
	}
	void setLength(double newLen)
	{
		double length = sqrt(coords[0] *coords[0] + coords[1] *coords[1] + coords[2]*coords[2]);
		coords[0] /= length;
		coords[1] /= length;
		coords[2] /= length;
		if(newLen != 1)
		{
			coords[0] *= newLen;
			coords[1] *= newLen;
			coords[2] *= newLen;
		}
	}
	Coord3d cross(Coord3d & target)
	{
		Coord3d res;
		res.coords[0] = target.coords[2] * coords[1] - target.coords[1]*coords[2];
		res.coords[1] = target.coords[0] * coords[2] - target.coords[2]*coords[0];
		res.coords[2] = target.coords[1] * coords[0] - target.coords[0]*coords[1];
		return res;
	}	
	double dot(Coord3d * target)
	{
		return target->coords[0] * coords[0] +target->coords[1] * coords[1] +target->coords[2] * coords[2];
	}
	Coord3d invert()
	{
		return Coord3d(coords[0] * -1,coords[1] * -1,coords[2] * -1);	
	}
	void getBarycentricCoords(Coord3d * v1,Coord3d * v2,Coord3d * v3,double * alpha,double * beta,double * gamma)
	{
		Vertex r1;
		Vertex r2;
		r1 = v3->sub(v1);
		r2 = v2->sub(v1);
		double TotalA = (r1.cross(r2)).getLength();		
		r1 = v3->sub(this);
		r2 = v2->sub(this);
		*alpha = (r1.cross(r2)).getLength() /TotalA;
		r1 = v1->sub(this);
		r2 = v3->sub(this);		
		*beta = (r1.cross(r2)).getLength()/TotalA;
		r2 = v2->sub(this);		
		*gamma = (r1.cross(r2)).getLength() / TotalA;
	}
	Coord3d rotateInX(double angle)
	{
		double radians = angle / 180 * PI;
		double newX = getX();
		double newY = getY() * cos(radians) - getZ() * sin(radians);
		double newZ = getY() * sin(radians) + getZ() * cos(radians);
		return Coord3d(newX,newY,newZ);
	}		
	Coord3d rotateInY(double angle)
	{
		double radians = angle / 180 * PI;
		double newX = getX() * cos(radians) + getZ() * sin(radians);		
		double newY = getY();
		double newZ = -getX() * sin(radians) + getZ() * cos(radians);
		return Coord3d(newX,newY,newZ);	
	}
	Coord3d rotateInZ(double angle)
	{
		double radians = angle / 180 * PI;
		double newX = getX() * cos(radians) - getY() * sin(radians);
		double newY = getX() * sin(radians) + getY() * cos(radians);
		double newZ = getZ();		
		return Coord3d(newX,newY,newZ);
	}
	Coord3d rotateinArbitrary(double angle, Arrow * axis)
	{
		axis->setLength(1);
		double radians = angle / 180 * PI;
		double c = cos(radians);
		double s = sin(radians);
		double t = 1 - c;

		Arrow result;
		Arrow v1 = this->mul(c);
		Arrow v2 = axis->mul(t * axis->dot(this));
		Arrow v3 = axis->cross(*this);
		v3 = v3.mul(s);
		result = v1.add(&v2);
		result = result.add(&v3);

		//V' = cos(t) V  + (1 - cos(t)) (A dot V) A + sin(t) A cross V
		
		return result;

	}
	double angleBetween(Coord3d * vOther,Coord3d * upVector,Coord3d * actualUp = 0)
	{
		double ang,theCos;
		this->setLength(1);
		vOther->setLength(1);
		theCos = this->dot(vOther);
		
		if (theCos >= 0.999999) 
			ang = 0.0;
		else if (theCos <= -0.999999)
			ang = PI;
		else
			ang = acos(theCos);
		if(upVector == 0)
			return ang * 180.0 /PI;
		
		Arrow w = upVector->cross(*this);
		Arrow upAxis =  this->cross(w);
		if(actualUp != 0)
			*actualUp = upAxis;
		Arrow left = upAxis.cross(*this);
		double bPleft = vOther->dot(&left);
		if(bPleft > 0)
			return ang * 180.0 /PI;
		else
			return -ang * 180.0 /PI;
	}
};


#endif




