#ifndef MANYTOWERS
#define MANYTOWERS

#include "tower.h"
#include "terrain.cpp"
#include "common.h"

#define NUMTOWERS 4

class ManyTowers
{
public:
	Tower* tower;
	Vertex locations[NUMTOWERS];
	ManyTowers(Terrain* terrain)
	{
		tower = new Tower(terrain);
		
		for(int i = 0; i < NUMTOWERS; i++)
		{
			double x = random() % (int)(RIGHT - 5000);
			double z = random() % (int)((FAR*-1) - 5000);
			z *= -1;
			double y = terrain->heightFunction(x,z)- 100;
			locations[i].set(x,y,z);
		}
	}
	~ManyTowers()
	{
		delete tower;
	}
	
	void init()
	{
		tower->init();
	}
	
	void draw()
	{
		float angle = 0.0;
		for(int i = 0; i < NUMTOWERS; i++)
		{
			glPushMatrix();
				glTranslatef(locations[i].getX(), locations[i].getY(), locations[i].getZ());
				glRotatef(angle, 0,1,0);
				tower->draw();
			glPopMatrix();
			angle += 90;
		}
		
		tower->update();
	}
};

#endif
