#ifndef RADAR
#define RADAR

#include "common.h"
#include "object.cpp"
#include "collisionmanager.h"
#include "terrain.cpp"

class Radar
{
public:
	CollisionManager* cm;
	GLUquadricObj* quad;

	Radar(CollisionManager* cm)
	{
		this->cm = cm;
	}
	
	void draw()
	{
		static bool quadinitted = false;
		if(!quadinitted) //as opposed to an init method
		{
			quad = gluNewQuadric();
			gluQuadricDrawStyle(quad, GLU_FILL);
			quadinitted = true;
		}
		
		glDisable(GL_LIGHTING);
		glDisable(GL_TEXTURE_2D);
		
		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glLoadIdentity();
		glOrtho(0, 1, 0, 1, -200, 200);
		
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
			glTranslatef(0.7, 0.91, 190.0);
			glColor3f(0,0,0);
			glRasterPos2f(0, 0);
			char* s;
			sprintf(s, "%d", score);
			for(int i = 0, len = strlen(s); i < len; i++)
			{
				glutBitmapCharacter(GLUT_BITMAP_9_BY_15, s[i]);
			}
			glTranslatef(0.0, -0.21, 0.0);
			glScalef(0.2, 0.2, 1.0);
			glColor4f(0, 1, 0, 0.3);
			glRectf(0, 0, 1, 1);
			glTranslatef(0.0,0.0,0.1);
			
			for(unsigned int i = 0; i < cm->collisionList.size(); i++)
			{
				Object* ob = cm->collisionList[i];
				if(ob->isEnemy)
				{
					glColor4f(1, 0, 0, 1.0);
					double x = ob->position.getX() / RIGHT;
					double y = ob->position.getZ() / FAR;
					double xdir = ob->unitVelocity.getX();
					double ydir = ob->unitVelocity.getZ() * -1;
					double len = sqrt(xdir*xdir + ydir*ydir);
					xdir /= len; ydir /= len;
					double xl, rl, xr, rr;
					xl = -1*ydir; rl = xdir;
					xr = -1*xl; rr = -1*rl;
					xl *= 0.3; rl *= 0.3; xr *= 0.3; rr *= 0.3;
					glPushMatrix();
						glTranslated(x, y, 0.0);
						glScalef(0.07, 0.07, 1.0);
						glBegin(GL_TRIANGLES);
							glVertex2d(xdir, ydir);
							glVertex2d(xl, rl);
							glVertex2d(xr, rr);
						glEnd();
					glPopMatrix();
				}
				else if(ob->isHero)
				{
					glColor4f(0, 0, 1, 1.0);
					double x = ob->position.getX() / RIGHT;
					double y = ob->position.getZ() / FAR;
					double xdir = ob->unitVelocity.getX();
					double ydir = ob->unitVelocity.getZ() * -1;
					double len = sqrt(xdir*xdir + ydir*ydir);
					xdir /= len; ydir /= len;
					double xl, rl, xr, rr;
					xl = -1*ydir; rl = xdir;
					xr = -1*xl; rr = -1*rl;
					xl *= 0.3; rl *= 0.3; xr *= 0.3; rr *= 0.3;
					glPushMatrix();
						glTranslated(x, y, 0.0);
						glScalef(0.1, 0.1, 1.0);
						glBegin(GL_TRIANGLES);
							glVertex2d(xdir, ydir);
							glVertex2d(xl, rl);
							glVertex2d(xr, rr);
						glEnd();
					glPopMatrix();
				}
			}
			
		glPopMatrix();
		
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
		
		glMatrixMode(GL_MODELVIEW);
		
		glEnable(GL_LIGHTING);
	}
};

#endif
