#ifndef TOWER
#define TOWER

#include "common.h"
#include "custombox.cpp"
#include "corner.cpp"
#include "texture.h"
#include "mytime.h"
#include "perlin2d.h"
#include "geometry.cpp"
#include "face.cpp"
#include "terrain.cpp"
#include "fire.h"
#include "firewell.cpp"
#include "object.cpp"
#include "Kangaroo.h"

#define FLAGSIZE 32

class Tower :public Object
{
public:
	Tower();
	~Tower();
	void init(Vertex * startPos,Terrain * terrain);
	void drawBody();
	void update();
	
private:
	void drawTower();
	double size;

	CustomBox base;
	CustomBox support;
	CustomBox roof;
	GLUquadricObj* quad;
	TEXTURE concrete;
	
	//for the flag
	TEXTURE xkang;
	void testAndUpdate();
	void updateFlag();
	void drawFlag();
	Terrain * terrain;
	MyTime time;
	PerlinNoise2D* noise;
	Corner nodes[FLAGSIZE][FLAGSIZE];
	Face faces[(FLAGSIZE-1)*(2*(FLAGSIZE-1))];
	int step; //[0,FLAGSIZE)
	
	Fire fire;
	FireWell well;
	
	Kangaroo roo;
};

#endif
