#include "tree.h"

extern TEXTURE treeTex;

Tree::Tree(void)
{
	this->isFlying = false;
	hitPoints = 1;
}

Tree::~Tree(void)
{

}
void Tree::init(Vertex * startPos,Terrain * terrain)
{
	treeQuadric = gluNewQuadric(); //i moved this from the constructor
	gluQuadricTexture(treeQuadric, GL_TRUE);
	
	position = startPos;
	this->terrain = terrain;
	double y;
	terrain->getHeightAndNormal(position.getX(),position.getZ(),&y,&startNormal);
	startNormal.setLength(1);
	position.setY(y);
	Arrow temp = startNormal.mul(-5);
	position = position.sub(&temp);
	this->unitVelocity.set(0,0,0);
	startAngle = rand() %360;
	height = 300 + abs(rand()) % 500;
	temp = startNormal.mul(height /2);
	position = position.add(&temp);

	width = height / 12;
	children = 4 + abs(rand()) %2;
	this->collisionInfo.boundingRadius = height /2;

	thisDL = glGenLists(1);
	glNewList(thisDL,GL_COMPILE);
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, treeTex.TexID);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	glColor3f(1,1,1);
	glPushMatrix();
	glTranslatef(position.getX(),position.getY(),position.getZ());	
	temp= temp.mul(-1);
	glTranslatef(temp.getX(),temp.getY(),temp.getZ());	//center the bounding radius in the middle of the tree
	glColor3f(0.4,0.4,0.4);
	Arrow axis = zAxis.cross(startNormal);		
	double angle = zAxis.angleBetween(&startNormal,0);	
	glRotatef(angle,axis.getX(),axis.getY(),axis.getZ());
	drawBranch(width,height,children);
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
	glEndList();

	
}
void Tree::drawBody()
{
	glCallList(thisDL);
	
	if(hitPoints <= 0)
	{
		glPushMatrix();
			glTranslatef(position.getX(), position.getY(), position.getZ());
			glPushMatrix();
				glTranslatef(0,100, 0);
				glScalef(75,150,75);
				smoke.draw();
			glPopMatrix();
			glTranslatef(0,-100,0);
			glScalef(100,100,100);
			fire.draw();
		glPopMatrix();
		fire.update();
		smoke.update();
	}
/*	
	glPushMatrix();
	glTranslatef(position.getX(),position.getY(),position.getZ());		
	glColor3f(0.4,0.4,0.4);
	Arrow axis = zAxis.cross(startNormal);		
	double angle = zAxis.angleBetween(&startNormal,0);	
	glRotatef(angle,axis.getX(),axis.getY(),axis.getZ());
	drawBranch(width,height,children);
	glPopMatrix();
	*/

}
void Tree::drawBranch(double width,double height, int children)
{
	glPushMatrix();
	gluCylinder(treeQuadric,width,width/6,height,12,12);
	if(children > 0)
	{
		double angleInc= 360 / children; //some randomness
		double distInc = height / (children * 1.2);
		double currAngle = startAngle;
		for(int i =0;i < children;i++)
		{	
			glTranslatef(0,0,distInc); //initial branch increment
			glPushMatrix();
			glRotatef(currAngle,0,0,1);
			glRotatef(30,0,1,0);
			drawBranch(width / 3,height /2,children -1);
			currAngle +=angleInc;
			glPopMatrix();
		}
	}
	glPopMatrix();
}

