#include "wall.h"

Wall::Wall(Terrain* terrain)
{
	this->terrain = terrain;
}

Wall::~Wall()
{
	
}

void Wall::draw()
{
	static bool generated = false;
	if(generated)
		glCallList(dlist);
	else
	{
		const int offset = 1000;
		const int left = int(LEFT) + offset;
		const int right = int(RIGHT) - offset;
		const int near = int(NEAR) - offset;
		const int far = int(FAR) + offset;
		Corner a, b, c, d, ab, bb, cb, db;
		CustomBox box;
		dlist = glGenLists(1);
		glNewList(dlist, GL_COMPILE);
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, wallTex.TexID);
			glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
			glColor3f(0.9, 0.9, 0.9);
			
			glMatrixMode(GL_TEXTURE);
			glPushMatrix();
				glScalef(10, 1, 1);
				for(int i = left; i < right; i+= SEGLENGTH)
				{
					double z = near;
					double x1 = i;
					double x2 = i + SEGLENGTH;
					double y1 = terrain->heightFunction(x1, z);
					double y2 = terrain->heightFunction(x2, z);
					
					a.set(x1, y1+WALLHEIGHT, z);
					b.set(x1, y1, z);
					c.set(x2, y2, z);
					d.set(x2, y2+WALLHEIGHT, z);
					ab.set(x1, y1+WALLHEIGHT, z+WALLWIDTH);
					bb.set(x1, y1, z+WALLWIDTH);
					cb.set(x2, y2, z+WALLWIDTH);
					db.set(x2, y2+WALLHEIGHT, z+WALLWIDTH);
					box.set(&a, &b, &c, &d, &ab, &bb, &cb, &db);
					
					box.draw();
					glTranslatef(-0.1, 0, 0);
				}
			glPopMatrix();
			
			glPushMatrix();
				glScalef(10, 1, 1);
				for(int i = left; i < right; i += SEGLENGTH)
				{
					double z = far;
					double x1 = i;
					double x2 = i + SEGLENGTH;
					double y1 = terrain->heightFunction(x1, z);
					double y2 = terrain->heightFunction(x2, z);
					
					a.set(x1, y1+WALLHEIGHT, z);
					b.set(x1, y1, z);
					c.set(x2, y2, z);
					d.set(x2, y2+WALLHEIGHT, z);
					ab.set(x1, y1+WALLHEIGHT, z+WALLWIDTH);
					bb.set(x1, y1, z+WALLWIDTH);
					cb.set(x2, y2, z+WALLWIDTH);
					db.set(x2, y2+WALLHEIGHT, z+WALLWIDTH);
					box.set(&a, &b, &c, &d, &ab, &bb, &cb, &db);
					
					box.draw();
					glTranslatef(-0.1, 0, 0);
				}
			glPopMatrix();
			
			glPushMatrix();
				glScalef(1, 10, 1);
				for(int i = near; i > far; i -= SEGLENGTH)
				{
					double x = left;
					double z1 = i;
					double z2 = i - SEGLENGTH;
					double y1 = terrain->heightFunction(x, z1);
					double y2 = terrain->heightFunction(x, z2);
					
					a.set(x, y1+WALLHEIGHT, z1);
					b.set(x, y2+WALLHEIGHT, z2);
					c.set(x, y2, z2);
					d.set(x, y1, z1);
					ab.set(x-WALLWIDTH, y1+WALLHEIGHT, z1);
					bb.set(x-WALLWIDTH, y2+WALLHEIGHT, z2);
					cb.set(x-WALLWIDTH, y2, z2);
					db.set(x-WALLWIDTH, y1, z1);
					box.set(&a, &b, &c, &d, &ab, &bb, &cb, &db);
					
					box.draw();
					glTranslatef(1, -0.1, 0);
				}
			glPopMatrix();
				
			glPushMatrix();
				glScalef(1, 10, 1);
				for(int i = near; i > far; i -= SEGLENGTH)
				{
					double x = right;
					double z1 = i;
					double z2 = i - SEGLENGTH;
					double y1 = terrain->heightFunction(x, z1);
					double y2 = terrain->heightFunction(x, z2);
					
					a.set(x, y1+WALLHEIGHT, z1);
					b.set(x, y2+WALLHEIGHT, z2);
					c.set(x, y2, z2);
					d.set(x, y1, z1);
					ab.set(x+WALLWIDTH, y1+WALLHEIGHT, z1);
					bb.set(x+WALLWIDTH, y2+WALLHEIGHT, z2);
					cb.set(x+WALLWIDTH, y2, z2);
					db.set(x+WALLWIDTH, y1, z1);
					box.set(&a, &b, &c, &d, &ab, &bb, &cb, &db);
					
					box.draw();
					glTranslatef(1, -0.1, 0);
				}
			glPopMatrix();
			glMatrixMode(GL_MODELVIEW);
		glEndList();
		generated = true;
	}
}
